VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Desktop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Type STARTUPINFO
    cb              As Long
    lpReserved      As String
    lpDesktop       As String
    lpTitle         As String
    dwX             As Long
    dwY             As Long
    dwXSize         As Long
    dwYSize         As Long
    dwXCountChars   As Long
    dwYCountChars   As Long
    dwFillAttribute As Long
    dwFlags         As Long
    wShowWindow     As Integer
    cbReserved2     As Integer
    lpReserved2     As Long
    hStdInput       As Long
    hStdOutput      As Long
    hStdError       As Long
End Type
      
Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, lpProcessAttributes As Any, lpThreadAttributes As Any, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, lpEnvironment As Any, ByVal lpCurrentDriectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Private Declare Function SHAddToRecentDocs Lib "shell32.dll" (ByVal dwFlags As Long, ByVal dwData As String) As Long
Private Declare Function SHQueryRecycleBin Lib "shell32.dll" Alias "SHQueryRecycleBinA" (ByVal pszRootPath As String, pSHQueryRBInfo As SHQUERYRBINFO) As Long
Private Declare Function SHEmptyRecycleBin Lib "shell32.dll" Alias "SHEmptyRecycleBinA" (ByVal hwnd As Long, ByVal pszRootPath As String, ByVal dwFlags As Long) As Long
Private Declare Function SHUpdateRecycleBinIcon Lib "shell32.dll" () As Long
Private Declare Function SHAppBarMessage Lib "shell32.dll" (ByVal dwMessage As Long, pData As APPBARDATA) As Long
Private Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As Long) As Long
Private Declare Function SetSystemCursor Lib "user32" (ByVal hcur As Long, ByVal id As Long) As Boolean
Private Declare Function DestroyCursor Lib "user32" (ByVal hCursor As Long) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function EnableTheming Lib "UxTheme.dll" (ByVal fEnable As Boolean) As Long
Private Declare Function IsThemeActive Lib "UxTheme.dll" () As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As gRECT) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function SystemParametersInfo2 Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
Private Declare Function BeginPath Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function EndPath Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function PathToRegion Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function TextOutW Lib "gdi32.dll" (ByVal hDC As Long, ByVal nXStart As Long, ByVal nYStart As Long, ByVal lpString As Long, ByVal cbString As Long) As Long
Private Declare Function GetTextExtentPoint32W Lib "gdi32.dll" (ByVal hDC As Long, ByVal lpString As Long, ByVal cbString As Long, ByRef lpSize As Size) As Long
Private Declare Function InvalidateRect Lib "user32" (ByVal hwnd As Long, lpRect As Any, ByVal bErase As Long) As Long
Private Declare Function EnumDisplaySettings Lib "user32" Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, ByVal iModeNum As Long, lpDevMode As Any) As Boolean
Private Declare Function ChangeDisplaySettings Lib "user32" Alias "ChangeDisplaySettingsA" (lpDevMode As Any, ByVal dwFlags As Long) As Long
Private Declare Function WriteProcessMemory Lib "kernel32" (ByVal hProcess As Long, lpBaseAddress As Any, lpBuffer As Any, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long
Private Declare Function ReadProcessMemory Lib "kernel32" (ByVal hProcess As Long, lpBaseAddress As Any, lpBuffer As Any, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetCurrentThreadId Lib "kernel32" () As Long
Private Declare Function GetThreadDesktop Lib "user32" (ByVal dwThread As Long) As Long
Private Declare Function OpenInputDesktop Lib "user32" (ByVal dwFlags As Long, ByVal fInherit As Boolean, ByVal dwDesiredAccess As Long) As Long
Private Declare Function CreateDesktop Lib "user32" Alias "CreateDesktopW" (ByVal lpszDesktop As Long, ByVal lpszDevice As Long, pDevMode As Any, ByVal dwFlags As Long, ByVal dwDesiredAccess As Long, lpsa As Any) As Long
Private Declare Function SetThreadDesktop Lib "user32.dll" (ByVal hDesktop As Long) As Long
Private Declare Function SwitchDesktop Lib "user32" (ByVal hDesktop As Long) As Long
Private Declare Function CloseDesktop Lib "user32.dll" (ByVal hDesktop As Long) As Long
Private Declare Function GetProcessWindowStation Lib "user32" () As Long
Private Declare Function EnumDesktops Lib "user32" Alias "EnumDesktopsA" (ByVal hwinsta As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long

Private Const CCDEVICENAME As Long = 32&
Private Const CCFORMNAME As Long = 32&

Public Enum DeskTopTextAlignment
    dtCenter = 0
    dtLeftJustify = 1
    dtRightJustify = 2
    dtByUser = 4
End Enum

Public Enum DeskCommand
    dcCreate_New = 0
    dcUnload = 1
    dcExecute = 2
    dcUnload_All = 4
    dcSwitchDesktop = 8
    dcGetDesktops = 16
End Enum

Public Type DesktopAPIinfo
    OldThread  As Long
    OldInput   As Long
    mDesktop   As Long
    Name       As String
End Type

Private Type DevMode
    dmDeviceName       As String * CCDEVICENAME
    dmSpecVersion      As Integer
    dmDriverVersion    As Integer
    dmSize             As Integer
    dmDriverExtra      As Integer
    dmFields           As Long
    dmOrientation      As Integer
    dmPaperSize        As Integer
    dmPaperLength      As Integer
    dmPaperWidth       As Integer
    dmScale            As Integer
    dmCopies           As Integer
    dmDefaultSource    As Integer
    dmPrintQuality     As Integer
    dmColor            As Integer
    dmDuplex           As Integer
    dmYResolution      As Integer
    dmTTOption         As Integer
    dmCollate          As Integer
    dmFormName         As String * CCFORMNAME
    dmUnusedPadding    As Integer
    dmBitsPerPel       As Integer
    dmPelsWidth        As Long
    dmPelsHeight       As Long
    dmDisplayFlags     As Long
    dmDisplayFrequency As Long
End Type

Public Type RECYCLEBININFO
    Size      As Long
    ITEMCOUNT As Long
    EMPTY     As Boolean
End Type

Public Type DESKTOPTEXTINFO
    TEXT              As String
    Top               As Long
    Left              As Long
    TextAlignment     As DeskTopTextAlignment
    StayOnTop         As Boolean
    Font              As StdFont
    Clear             As Boolean
    FontColor         As Long
    Transparenz       As Byte
    ClearAll          As Boolean
End Type

Private Type APPBARDATA
    cbSize           As Long
    hwnd             As Long
    uCallbackMessage As Long
    uEdge            As Long
    rc               As RECT
    lParam           As Long
End Type

Private Type ULARGE_INTEGER
    LowPart  As Long
    HighPart As Long
End Type

Private Type SHQUERYRBINFO
    cbSize      As Long
    i64Size     As ULARGE_INTEGER
    i64NumItems As ULARGE_INTEGER
End Type

Private Type Size
    cX As Long
    cY As Long
End Type

Public Type gRECT
    Left   As Long
    Top    As Long
    Width  As Long
    Height As Long
End Type

Public Enum DESKTOPRESULOTION
    dr640x480 = 0
    dr800x600 = 1
    dr960x600 = 2
    dr1024x768 = 3
    dr1088x612 = 4
    dr1152x864 = 5
    dr1280x720 = 6
    dr1280x768 = 7
    dr1280x800 = 8
    dr1280x960 = 9
    dr1280x1024 = 10
    dr1360x768 = 11
    dr1600x900 = 12
    dr1600x1024 = 13
    dr1600x1200 = 14
    drOTHERRESULOTION = 15
End Enum

Public Enum SystemPanelApp
    syControlPanel = 1
    syRemove_Software = 2
    syAdd_Software = 3
    syAdd_Remove_WindowsComponents = 4
    sySystemInformation = 5
    syComputerNameSettings = 6
    syHardwareManager = 7
    syTime_Date_Settings = 8
    syRegional_Settings = 9
    syDisplay_Settings = 10
    syInternet_Settings = 11
    syKeyboard_Settings = 12
    syMouse_Settings = 13
    syModem_Settings = 14
    sySound_Settings = 15
    syNew_Printer = 16
    syInput_Assistance = 17
    syCountrie_Attitudes = 18
    syODCB_Settings = 19
    syGame_Settings = 20
    syWindows_Update = 21
End Enum

Public Enum SYSTEMDIR
    sdMYCOMPUTER = 1
    sdRECYCLEBIN = 2
    sdSYSTEMPANEL = 3
    sdNETWORKCONNECTIONS = 4
    sdNETWORKENVIRONMENT = 5
    sdPRINTER = 6
End Enum

Public Enum DesktopHWND
    dtTRAY = 1
    dtDESKTOP = 2
    dtSTARTBUTTON = 3
    dtTASKBAR = 4
    dtCLOCK = 5
    dtSTARTMENU = 6
    dtPROGRAMMANAGER = 7
End Enum

Public Enum DEFAULTCURSOR
    dcCROSS = 32515
    dcHAND = 32649
    dcIBEAM = 32513
    dcNO = 32648
    dcNORMAL = 32512
    dcSIZEALL = 32646
    dcSIZENESW = 32643
    dcSIZENS = 32645
    dcSIZEWE = 32644
    dcSIZENWSE = 32642
    dcUP = 32516
    dcWAIT = 32514
End Enum

Public Enum RECENTDOCSCOMMAND
    rdADDFILE = 1
    rdCLEAR = 2
End Enum

Public Enum DESKTOPSYSTEMICON
    diRECYCLEBIN = 1
    diMYCOMPUTER = 2
    diSYSTEMPANEL = 3
    diNETNEIGHBOURHOOD = 4
End Enum

Private Const IDM_TOGGLEAUTOARRANGE = &H7041

Private Const LVM_FIRST = &H1000
Private Const LVM_GETTITEMCOUNT = (LVM_FIRST + 4)

Dim Desktop_AutoArrange As Boolean

Dim ptOriginal() As POINTAPI

Dim DA() As DesktopAPIinfo

Public Sub RecycleBin_Info(RECYCLEBININFO As RECYCLEBININFO)
    Dim RBinInfo As SHQUERYRBINFO
    
    RBinInfo.cbSize = Len(RBinInfo)
    Call SHQueryRecycleBin(vbNullString, RBinInfo)

    RECYCLEBININFO.ITEMCOUNT = RBinInfo.i64NumItems.LowPart
    RECYCLEBININFO.Size = RBinInfo.i64Size.LowPart
    RECYCLEBININFO.EMPTY = (RECYCLEBININFO.ITEMCOUNT = 0)
    
End Sub
Public Sub RecycleBin_Clear(ByVal hwnd As Long, _
                            Optional Confirm As Boolean = False, _
                            Optional ShowProgress As Boolean = False, _
                            Optional PlaySound As Boolean = False)
    Dim dwFlags As Long
    
    Const SHERB_NOPROGRESSUI = &H2
    Const SHERB_NOCONFIRMATION = &H1
    Const SHERB_NOSOUND = &H4

    If Not Confirm Then dwFlags = dwFlags Or SHERB_NOCONFIRMATION
    If Not ShowProgress Then dwFlags = dwFlags Or SHERB_NOPROGRESSUI
    If Not PlaySound Then dwFlags = dwFlags Or SHERB_NOSOUND
                        
    Call SHEmptyRecycleBin(hwnd, vbNullString, dwFlags)
    Call RecycleBin_UpdateIcon
    
End Sub
Public Sub RecycleBin_UpdateIcon()

    Call SHUpdateRecycleBinIcon

End Sub
Public Function Get_DesktopDimensions() As CONTROLDIMENSIONS

    Get_DesktopDimensions.Width = Screen.Width / Screen.TwipsPerPixelX
    Get_DesktopDimensions.Height = Screen.Height / Screen.TwipsPerPixelX

End Function
Public Function Get_WorkAreaDimension() As CONTROLDIMENSIONS
    Dim R As RECT

    Call SystemParametersInfo2(SPI_GETWORKAREA, 0, R, 0)

    Get_WorkAreaDimension.Width = (R.Right - R.Left) * Screen.TwipsPerPixelX
    Get_WorkAreaDimension.Height = (R.Bottom - R.Top) * Screen.TwipsPerPixelX

End Function
Public Sub RecentDocs(Command As RECENTDOCSCOMMAND, Optional File As String)
    
    Const SHARD_PATH = &H2&

    Select Case Command
        Case rdADDFILE
            Call SHAddToRecentDocs(SHARD_PATH, File)
        Case rdCLEAR
            Call SHAddToRecentDocs(SHARD_PATH, vbNullString)
    End Select
    
End Sub
Public Sub Get_TaskbarPos(TaskBar As CONTROLPOSITION)
    Dim TPos As APPBARDATA
        
    Const ABM_GETTASKBARPOS = &H5

    Call SHAppBarMessage(ABM_GETTASKBARPOS, TPos)
    
    TaskBar.Left = TPos.rc.Left
    TaskBar.Top = TPos.rc.Top
    TaskBar.Right = TPos.rc.Right
    TaskBar.Bottom = TPos.rc.Bottom

End Sub
Public Function Wallpaper_Change(ByVal File As String) As Boolean
    Dim Result As Long
    
    Const SPIF_SENDWININICHANGE = &H2
    Const SPIF_UPDATEINIFILE = &H1
    Const SPI_SETDESKWALLPAPER = 20

    Result = SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, File, SPIF_UPDATEINIFILE Or SPIF_SENDWININICHANGE)
    Wallpaper_Change = (Result <> 0)

End Function
Public Function Wallpaper_Clear() As Boolean
    
    Wallpaper_Clear = Wallpaper_Change("")

End Function
Public Function SystemPanel(SystemPanelApp As SystemPanelApp, _
                            Optional ErrorNumber As Long) As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    Select Case SystemPanelApp
        Case syControlPanel
            R$ = DLL.DESKTOP.SystemDirOpen(sdSYSTEMPANEL)
            
            Exit Function
        Case syRemove_Software
            R$ = " appwiz.cpl,,0" & Chr$(34) & ", 1"
        Case syAdd_Software
            R$ = " appwiz.cpl,,1" & Chr$(34) & ", 1"
        Case syAdd_Remove_WindowsComponents
            R$ = " appwiz.cpl,,2" & Chr$(34) & ", 1"
        Case sySystemInformation
            R$ = " sysdm.cpl,,0" & Chr$(34) & ", 1"
        Case syComputerNameSettings
            R$ = " sysdm.cpl,,1" & Chr$(34) & ", 1"
        Case syHardwareManager
            R$ = " sysdm.cpl,,2" & Chr$(34) & ", 1"
        Case syTime_Date_Settings
            R$ = " timedate.cpl" & Chr$(34) & ", 1"
        Case syRegional_Settings
            R$ = " intl.cpl,,0" & Chr$(34) & ", 1"
        Case syDisplay_Settings
            R$ = " desk.cpl,,0" & Chr$(34) & ", 1"
        Case syInternet_Settings
            R$ = " inetcpl.cpl,,0" & Chr$(34) & ", 1"
        Case syKeyboard_Settings
            R$ = " main.cpl @1" & Chr$(34) & ", 1"
        Case syMouse_Settings
            R$ = " main.cpl @0" & Chr$(34) & ", 1"
        Case syModem_Settings
            R$ = " modem.cpl" & Chr$(34) & ", 1"
        Case sySound_Settings
            R$ = " mmsys.cpl @1" & Chr$(34) & ", 5"
        Case syNew_Printer
            SystemPanel = SHELL("rundll32.exe shell32.dll,SHHelpShortcuts_RunDLL AddPrinter", 1)
            
            Exit Function
        Case syInput_Assistance
            R$ = " access.cpl @1" & Chr$(34) & ", 1"
        Case syCountrie_Attitudes
            R$ = " intl.cpl,,0" & Chr$(34) & ", 1"
        Case syODCB_Settings
            R$ = " odbccp32.cpl @1" & Chr$(34) & ", 1"
        Case syGame_Settings
            R$ = " joy.cpl @1" & Chr$(34) & ", 1"
        Case syWindows_Update
            R$ = " wuaucpl.cpl @1" & Chr$(34) & ", 1"
        Case Else
            Exit Function
    End Select
    
    SystemPanel = SHELL("rundll32.exe shell32.dll,Control_RunDLL" & R$)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    SystemPanel = -2

    Call ERROR(DESKTOP, "SystemPanel", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Sub StartButton_Click()
    
    Call DLL.WINDOW.Click(DesktopHWND(dtSTARTBUTTON))

End Sub
Public Function Wallpaper_GetPath() As String
    Dim sFilename As String * MAX_PATH
    Dim Result As Long
    
    Const SPI_GETDESKWALLPAPER = 115

    Result = SystemParametersInfo(SPI_GETDESKWALLPAPER, Len(sFilename), _
                                  ByVal sFilename, 0)

    Wallpaper_GetPath = Replace(sFilename, Chr$(0), "")
    
End Function
Public Function Wallpaper_Get(Optional ErrorNumber As Long) As IPictureDisp
    Dim Path As String
    Dim frm As New frmTMP
    
    On Local Error GoTo Quit
    
    Path = Wallpaper_GetPath
        
    If Path <> "" Then
        Load frm
        
        frm.Tag = "Wallpaper_Get"
        
        frm.picTMP.Visible = True
        frm.picTMP.AutoRedraw = True
        
        Set frm.picTMP = LoadPicture(Path)
        frm.picTMP.Refresh
        
        Set Wallpaper_Get = frm.picTMP.Picture
    End If
    
Quit:
    ErrorNumber = Err.Number
    
    Unload frm
    Set frm = Nothing
      
    Err.Clear
    
End Function
Public Sub Set_WindowsDefaultMouseCursor(Cursor As DEFAULTCURSOR)
    Dim hCursor As Long
    
    Static oldCursor As Long
    
    If oldCursor Then
        hCursor = LoadCursor(0, Cursor)
        
        Call SetSystemCursor(hCursor, dcNORMAL)
        Call DestroyCursor(hCursor)
    End If

    oldCursor = Cursor
    
    hCursor = LoadCursor(0, Cursor)
    
    Call SetSystemCursor(hCursor, dcNORMAL)
    Call DestroyCursor(hCursor)

End Sub
Public Sub SysTray_Refresh()
    Dim x As Long, Z As Long, hwnd As Long
    Dim rRect As RECT
    
    On Local Error GoTo Quit

    hwnd = FindSysTray
    If hwnd = 0 Then Exit Sub
    
    x = GetClientRect(hwnd, rRect)

    For Z = 0 To (rRect.Bottom / 20) - 1
        For x = 0 To rRect.Right
            Call SendMessage(hwnd, WM_MOUSEMOVE, 0, ByVal ((((Z * 20) + 10) * &H10000) Or x))
        Next x
    Next Z
    
Quit:
    Err.Clear
    
End Sub
Public Function Windows_Minimize(Optional RestoreWindows As Boolean = False) As Boolean
    Dim hwnd As Long, wMsg As Long
        
    wMsg = IIf(RestoreWindows, 416, 419)
    hwnd = DLL.WINDOW.FindWindow("Shell_TrayWnd", "")
    
    If hwnd Then
        If PostMessage(hwnd, WM_COMMAND, wMsg, 0&) Then Windows_Minimize = True
    End If
        
End Function
Public Function DesktopHWND(DeskHwnd As DesktopHWND) As Long
    Dim Child As Long, Parent As Long
    
    Select Case DeskHwnd
        Case dtSTARTBUTTON
            Parent = FindWindowA("Shell_TrayWnd", vbNullString)
            Child = FindWindowEx(Parent, 0, "Button", vbNullString)
            
            DesktopHWND = Child
        Case dtDESKTOP
            DesktopHWND = GetDesktopWindow()
        Case dtTRAY
            Parent = FindWindowA("Shell_TrayWnd", vbNullString)
            Child = FindWindowEx(Parent, 0, "TrayNotifyWnd", vbNullString)

            DesktopHWND = Child
        Case dtTASKBAR
            DesktopHWND = FindWindowA("Shell_TrayWnd", vbNullString)
        Case dtCLOCK
            Parent = FindWindowA("Shell_TrayWnd", vbNullString)
            Child = FindWindowEx(Parent, 0, "TrayNotifyWnd", vbNullString)
            Child = FindWindowEx(Child, 0, "TrayClockWClass", vbNullString)
        
            DesktopHWND = Child
        Case dtSTARTMENU
            Parent = FindWindowA("BaseBar", vbNullString)
            Parent = GetWindow(Parent, GW_HWNDNEXT)
            Parent = GetWindow(Parent, GW_HWNDNEXT)
            Child = FindWindowEx(Parent, 0, "MenuSite", vbNullString)
            Child = FindWindowEx(Child, 0, "ToolbarWindow32", vbNullString)
            
            DesktopHWND = Child
        Case dtPROGRAMMANAGER
            DesktopHWND = FindWindowA(vbNullString, "Program Manager")
        
        Case Else
            Exit Function
    End Select
    
End Function
Public Function SystemDirOpen(SysDir As SYSTEMDIR) As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    Select Case SysDir
        Case sdMYCOMPUTER
            R$ = "{20D04FE0-3AEA-1069-A2D8-08002B30309D}"
        Case sdNETWORKENVIRONMENT
            R$ = "{208D2C60-3AEA-1069-A2D7-08002B30309D}"
        Case sdNETWORKCONNECTIONS
            R$ = "{20D04FE0-3AEA-1069-A2D8-08002B30309D}" & _
                 "\::{21EC2020-3AEA-1069-A2DD-08002B30309D}" & _
                 "\::{7007acc7-3202-11d1-aad2-00805fc1270e}"
        Case sdRECYCLEBIN
            R$ = "{645FF040-5081-101B-9F08-00AA002F954E}"
        Case sdSYSTEMPANEL
            R$ = "{20D04FE0-3AEA-1069-A2D8-08002B30309D}" & _
                 "\::{21EC2020-3AEA-1069-A2DD-08002B30309D}"
        Case sdPRINTER
            R$ = "{2227A280-3AEA-1069-A2DE-08002B30309D}"
        Case Else
            Exit Function
    End Select
    
    Call SHELL("Explorer.exe ::" & R$, vbNormalFocus)
    
    Exit Function

Quit:
    SystemDirOpen = Err.Number

    Call ERROR(DESKTOP, "SystemDirOpen", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function XPtheme_isActive() As Boolean
    
    XPtheme_isActive = IsThemeActive

End Function
Public Function XPtheme_Enable(Optional Disable As Boolean = False) As Boolean
    
    XPtheme_Enable = (EnableTheming(IIf(Disable, False, True)) = 0)

End Function
Public Function SnapShot(Optional AreaLeft As Long = -1, _
                         Optional AreaTop As Long = -1, _
                         Optional AreaWidth As Long = -1, _
                         Optional AreaHeight As Long = -1, _
                         Optional ErrorNumber As Long) As StdPicture
    Dim hDC As Long, hwnd As Long, x As Long, Y As Long, Retval As Long
    Dim WIN As gRECT
    Dim frm As New MyControls

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Load frm
    
    With frm
        .Tag = "SnapShot"

        .picTMP.AutoRedraw = True
        .picTMP.AutoSize = False

        hwnd = GetDesktopWindow()
        hDC = GetDC(hwnd)

        If AreaLeft = -1 Or AreaTop = -1 Or AreaWidth = -1 Or AreaHeight = -1 Then
            Retval = GetWindowRect(hwnd, WIN)
            If Retval = 0 Then GoTo Quit
            
            x = WIN.Width
            Y = WIN.Height
    
            Call DLL.GRAFX.PixelToTwips(x, Y)

            .picTMP.Width = x
            .picTMP.Height = Y
    
            .picTMP.ZOrder
    
            DoEvents
    
            Retval = StretchBlt(.picTMP.hDC, WIN.Left, WIN.Top, WIN.Width, WIN.Height, hDC, 0, 0, WIN.Width, WIN.Height, SRCCOPY)
            If Retval = 0 Then GoTo Quit
            
            Call ReleaseDC(hwnd, hDC)
            
            Set frm.picTMP.Picture = frm.picTMP.Image
            frm.picTMP.Refresh

            DoEvents

            Set SnapShot = frm.picTMP.Picture
        
            GoTo Quit
        End If
    
        hwnd = GetDesktopWindow
        hDC = GetDC(hwnd)

        .Left = AreaLeft
        .Top = AreaTop
        .Width = AreaWidth
        .Height = AreaHeight
        
        With .picTMP
            .Top = 0
            .Left = 0
            .Width = frm.Width
            .Height = frm.Height
            .ZOrder
        End With
        
        DoEvents
        
        Retval = GetWindowRect(.hwnd, WIN)
    
        If Retval = 0 Then GoTo Quit
        'Die Abmessungen des Formulars konnten nicht bestimmt werden.
    
        Retval = BitBlt(.picTMP.hDC, 0, 0, .picTMP.Width, .picTMP.Height, hDC, WIN.Left, WIN.Top, SRCCOPY)
        If Retval = 0 Then GoTo Quit
        'Das Snapshot konnte nicht erstellt werden.
        
        Call ReleaseDC(hwnd, hDC)

        .picTMP.Refresh
        DoEvents
        
        Set SnapShot = .picTMP.Image
    End With
    
Quit:
    ErrorNumber = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(DESKTOP, "SnapShot", Err.Number, Err.Description)
        
    Unload frm
    Set frm = Nothing
    
    Err.Clear

End Function
Public Function WriteOnDesktop(DesktopText As DESKTOPTEXTINFO) As Long
    Dim P As Long, Pointer As Long, Length As Long, Device As Long, Region As Long, T As Long, L As Long
    Dim TextSize As Size
    Dim U As Boolean
    Dim WA As CONTROLDIMENSIONS
    
    On Local Error GoTo Quit
    
    If DesktopText.Clear Or DesktopText.ClearAll Then
        On Local Error Resume Next
        
        For P = FORMS.Count - 1 To 0 Step -1
            If FORMS(P).Tag = "WriteOnDesktop" Then
                U = False
                
                If DesktopText.ClearAll Then U = True
                If DesktopText.Clear And FORMS(P).DesktopText = DesktopText.TEXT Then U = True
                
                If U Then
                    Unload FORMS(P)
                    Set FORMS(P) = Nothing
                End If
            End If
        Next P
        
        Err.Clear
        
        Exit Function
    End If
    
    Dim frm As New frmTMP

    If DesktopText.Font Is Nothing Then
        Set DesktopText.Font = New StdFont
        
        DesktopText.Font.Name = "Times New Roman"
        DesktopText.Font.Size = 36
    End If
    
    If DesktopText.Font.Size = 0 Then DesktopText.Font.Size = 36
    
    Load frm
        
    With frm
        .Tag = "WriteOnDesktop"
        .DesktopText = DesktopText.TEXT
        
        If DesktopText.StayOnTop Then Call DLL.FORMS.StayOnTop(frm)
            
        If DesktopText.Transparenz = 0 Then DesktopText.Transparenz = 255
        Call DLL.WINDOW.Set_Transparenz(.hwnd, DesktopText.Transparenz)
            
        .BackColor = DesktopText.FontColor
        
        Set .Font = DesktopText.Font
        
        .LabelTMP.AutoSize = True
        .LabelTMP.Caption = DesktopText.TEXT
        
        Set .LabelTMP.Font = DesktopText.Font
        
        .Width = .LabelTMP.Width * vbTwips
        .Height = .LabelTMP.Height * vbTwips
        
        If DesktopText.TextAlignment <> dtByUser Then WA = Get_WorkAreaDimension
        
        Select Case DesktopText.TextAlignment
            Case dtByUser:       T = DesktopText.Top
                                 L = DesktopText.Left
            Case dtCenter:       T = (WA.Height / 2) - (.Height / 2)
                                 L = (WA.Width / 2) - (.Width / 2)
            Case dtLeftJustify:  T = (WA.Height / 2) - (.Height / 2)
                                 L = 0
            Case dtRightJustify: T = (WA.Height / 2) - (.Height / 2)
                                 L = WA.Width - .Width
        End Select
        
        .Top = T
        .Left = L
            
        Pointer = strptr(DesktopText.TEXT)
        Length = Len(DesktopText.TEXT)
        Device = .hDC
          
        GetTextExtentPoint32W Device, Pointer, Length, TextSize

        BeginPath Device
        TextOutW Device, 0, 0, Pointer, Length
        EndPath Device
        Region = PathToRegion(Device)

        SetWindowRgn .hwnd, Region, 1
                 
        .Visible = True
    End With

    Exit Function
    
Quit:
    WriteOnDesktop = Err.Number
    
    Call ERROR(DESKTOP, "WriteOnDesktop", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Sub DesktopIcon_Show(Optional Hide As Boolean = False)
    Dim hwnd As Long, mCmdShow As Long
    
    mCmdShow = IIf(Hide, basDeclar.SW_HIDE, basDeclar.SW_RESTORE)
    
    hwnd = DesktopHWND(dtPROGRAMMANAGER)
  
    If hwnd <> 0 Then Call ShowWindow(hwnd, mCmdShow)
  
End Sub
Public Sub DesktopSystemIcons_Rename(SystemIcon As DESKTOPSYSTEMICON, _
                                     ByVal NewName As String)
    Dim Path  As String
        
    Select Case SystemIcon
        Case diMYCOMPUTER
            Path = "{20D04FE0-3AEA-1069-A2D8-08002B30309D}"
        Case diNETNEIGHBOURHOOD
            Path = "{208D2C60-3AEA-1069-A2D7-08002B30309D}"
        Case diRECYCLEBIN
            Path = "{645FF040-5081-101B-9F08-00AA002F954E}"
        Case diSYSTEMPANEL
            Path = "{21EC2020-3AEA-1069-A2DD-08002B30309D}"
        Case Else
            Exit Sub
    End Select
    
    Path = "CLSID\" & Path
    
    Call DLL.REGISTRY.ValueSet(HKEY_CLASSES_ROOT_, Path, "", NewName)
                                        
    Call Desktop_Update
                            
End Sub
Public Sub Desktop_Update()
    Dim Result As Long
    
    Result = InvalidateRect(0&, 0&, False)
    If Result <> 0 Then Call InvalidateRect(0&, 0&, False)
  
End Sub
Public Sub ScreenSaver_Activate(Form As Object)
    
    Call SendMessage(Form.hwnd, WM_SYSCOMMAND, SC_SCREENSAVE, 0&)

End Sub
Public Function Set_DesktopResulotion(Resulotion As DESKTOPRESULOTION, Frequency As Byte, _
                                      Optional OtherResulotion As String) As Long
    Dim x As Long, Y As Long, Result As Long
    Dim Dev As DevMode
    Dim A() As String
    
    Const ENUM_CURRENT_SETTINGS = -1&
    Const DM_DISPLAYFREQUENCY = &H400000
    Const DM_PELSWIDTH = &H80000
    Const DM_PELSHEIGHT = &H100000
    Const CDS_UPDATEREGISTRY = &H1&
    Const CDS_TEST = &H4&

    On Local Error GoTo Quit
    
    Select Case Resulotion
        Case dr1024x768:  x = 1024: Y = 768
        Case dr1088x612:  x = 1088: Y = 612
        Case dr1152x864:  x = 1152: Y = 864
        Case dr1280x1024: x = 1280: Y = 1024
        Case dr1280x720:  x = 1280: Y = 720
        Case dr1280x768:  x = 1280: Y = 768
        Case dr1280x800:  x = 1280: Y = 800
        Case dr1280x960:  x = 1280: Y = 960
        Case dr1360x768:  x = 1360: Y = 768
        Case dr1600x1024: x = 1600: Y = 1024
        Case dr1600x1200: x = 1600: Y = 1200
        Case dr1600x900:  x = 1600: Y = 900
        Case dr640x480:   x = 640:  Y = 480
        Case dr800x600:   x = 800:  Y = 600
        Case dr960x600:   x = 960:  Y = 600
        
        Case drOTHERRESULOTION
                          OtherResulotion = LCase$(OtherResulotion)
                          A = Split(Resulotion, "x")
                
                          x = A(0): Y = A(1)
        Case Else:        Exit Function
    End Select
    
    Result = EnumDisplaySettings(0&, ENUM_CURRENT_SETTINGS, Dev)
    
    If Result <> 0 Then
        Dev.dmDisplayFrequency = Frequency
        Dev.dmFields = DM_PELSWIDTH Or DM_PELSHEIGHT Or DM_DISPLAYFREQUENCY
        Dev.dmPelsWidth = x
        Dev.dmPelsHeight = Y
   
        Result = ChangeDisplaySettings(Dev, CDS_TEST)
        Call ChangeDisplaySettings(Dev, CDS_UPDATEREGISTRY)
    End If
    
    Exit Function
    
Quit:
    Set_DesktopResulotion = Err.Number
    
    Call ERROR(DESKTOP, "Set_DesktopResulotion", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function DesktopIcon_Save() As Long
    Dim pid As Long, tid As Long
    Dim hProcess As Long, lpSysShared As Long, dwSize As Long
    Dim nCount As Long, lWritten As Long, hFileMapping As Long
    Dim H As Long, i As Long
    Dim xScreen As Long, yScreen As Long

    Const LVM_GETITEMPOSITION = (LVM_FIRST + 16)
    Const LVS_AUTOARRANGE = &H100

    On Local Error GoTo Quit
    
    H = GetSysLVHwnd
    If H = 0 Then Exit Function
  
    If (GetWindowLong(H, GWL_STYLE) And LVS_AUTOARRANGE) = LVS_AUTOARRANGE Then
        Desktop_AutoArrange = True
        
        Call SendMessage(GetParentA(H), WM_COMMAND, IDM_TOGGLEAUTOARRANGE, ByVal 0&)
    End If
  
    tid = GetWindowThreadProcessId(H, pid)
  
    nCount = SendMessage(H, LVM_GETTITEMCOUNT, 0, 0&)
    If nCount = 0 Then Exit Function
  
    xScreen = Screen.Width \ Screen.TwipsPerPixelX
    yScreen = Screen.Height \ Screen.TwipsPerPixelY
  
    ReDim ptOriginal(nCount - 1)
  
    dwSize = Len(ptOriginal(0))
  
    If DLL.SYSTEM.isWindowsNT Then
        lpSysShared = GetMemSharedNT(pid, dwSize, hProcess)
        WriteProcessMemory hProcess, ByVal lpSysShared, ptOriginal(0), dwSize, lWritten
     
        For i = 0 To nCount - 1
            SendMessage H, LVM_GETITEMPOSITION, i, ByVal lpSysShared
            ReadProcessMemory hProcess, ByVal lpSysShared, ptOriginal(i), dwSize, lWritten
        Next i
        
        FreeMemSharedNT hProcess, lpSysShared, dwSize
    Else
        lpSysShared = GetMemShared95(dwSize, hFileMapping)
        CopyMemory ByVal lpSysShared, ptOriginal(0), dwSize
     
        For i = 0 To nCount - 1
            SendMessage H, LVM_GETITEMPOSITION, i, ByVal lpSysShared
            CopyMemory ptOriginal(i), ByVal lpSysShared, dwSize
        Next i
     
        FreeMemShared95 hFileMapping, lpSysShared
    End If
  
    Exit Function
    
Quit:
    DesktopIcon_Save = Err.Number
    
    Call ERROR(DESKTOP, "DesktopIcon_Save", Err.Number, Err.Description)
    
    Erase ptOriginal()
    
    Err.Clear
    
End Function
Public Function DesktopIcon_Restore() As Long
    Dim H As Long, nCount As Long, i As Long
  
    Const LVM_SETITEMPOSITION = (LVM_FIRST + 15)

    On Local Error GoTo Quit
  
    H = GetSysLVHwnd
  
    nCount = SendMessage(H, LVM_GETTITEMCOUNT, 0, 0&)
  
    For i = 0 To nCount - 1
        Call SendMessage(H, LVM_SETITEMPOSITION, i, ByVal CLng(ptOriginal(i).x + ptOriginal(i).Y * &H10000))
    Next i
  
    If Desktop_AutoArrange Then
        Call SendMessage(GetParentA(H), WM_COMMAND, IDM_TOGGLEAUTOARRANGE, ByVal 0&)
    End If

    Exit Function
    
Quit:
    DesktopIcon_Restore = Err.Number
    
    Call ERROR(DESKTOP, "DesktopIcon_Restore", Err.Number, Err.Description)
    
    Erase ptOriginal()
    
    Err.Clear
    
End Function
Public Sub TaskBar_Show(Optional Hide As Boolean = False)
    Dim hwnd As Long, nCmdShow As Long
    
    nCmdShow = IIf(Hide, SW_HIDE, SW_SHOW)
        
    hwnd = FindWindowA("Shell_traywnd", vbNullString)
    
    Call ShowWindow(hwnd, nCmdShow)
    
End Sub
Public Sub TaskBar_Disable(ByVal DisableTaskBar As Boolean)
    Dim hwnd As Long
    
    hwnd = DesktopHWND(dtTASKBAR)
    Call DLL.WINDOW.EnableWindow(hwnd, Not (DisableTaskBar))

End Sub
Public Function TaskBar_AttachControl(Control As Object, _
                                      Optional Form_ForceWidth As Long = 0, _
                                      Optional Form_ForceHeight As Long = 0) As Long
    Dim TB As Long, intWidth As Long, intHeight As Long, P As Long, Index As Long
        
    On Local Error Resume Next

    Index = -1

    For P = 0 To UBound(OC)
        If Err.Number <> 0 Then Exit For
        
        If OC(P).hwnd = Control.hwnd Then
            Index = P
                                                     
            Exit For
        End If
    Next P
    
    Err.Clear
    
    If Index = -1 Then
        ReDim Preserve OC(UBound(OC) + 1)
        If Err.Number <> 0 Then ReDim OC(0)
        
        Index = UBound(OC)
        
        OC(Index).hwnd = Control.hwnd
        OC(Index).Parent = GetParentA(Control.hwnd)
        
        OC(Index).Height = Control.Height
        OC(Index).Left = Control.Left
        OC(Index).Top = Control.Top
        OC(Index).Width = Control.Width
    End If
    
    Err.Clear
    
    On Local Error GoTo Quit
    
    TB = DesktopHWND(dtTASKBAR)
    
    If Form_ForceWidth <> 0 Then
        intWidth = Form_ForceWidth
    Else
        intWidth = Control.Width
    End If
    
    If Form_ForceHeight <> 0 Then
        intHeight = Form_ForceHeight
    Else
        intHeight = Control.Height
    End If
    
    Call SetParentA(Control.hwnd, TB)
    Call Taskbar_AddForm(Control, intWidth, intHeight)
    
    Exit Function
    
Quit:
    TaskBar_AttachControl = Err.Number
    
    Call ERROR(DESKTOP, "Taskbar_AttachControl", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function TaskBar_DetachControl(Control As Object) As Long
    Dim hwnd As Long, P As Long, Index As Long
    
    On Local Error Resume Next
    
    Index = -1
    
    For P = 0 To UBound(OC)
        If Err.Number <> 0 Then Exit For
        
        If Control.hwnd = OC(P).hwnd Then
            Index = P
                                                     
            Exit For
        End If
    Next P
    
    Err.Clear
    
    On Local Error GoTo Quit
    
    hwnd = Control.hwnd

    If Index = -1 Then Exit Function
                      
    Call SetParentA(hwnd, OC(Index).Parent)
    
    Control.Height = OC(Index).Height
    Control.Left = OC(Index).Left
    Control.Top = OC(Index).Top
    Control.Width = OC(Index).Width

    Control.Refresh
    DoEvents
    
    OC(Index).hwnd = -1

    Exit Function

Quit:
    TaskBar_DetachControl = Err.Number
    
    Call ERROR(DESKTOP, "Taskbar_DetachControl", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Sub MyComputer_SetIcon(ByVal AppName As String, ByVal AppPath As String, _
                              ByVal AppInfoTip As String)
    Dim CLASSID As String, Hex As String
    Dim id As Long
    
    CLASSID = "{00000000-0000-0000-8000-00AA000D0EA0}"
    id = DLL.MATH.HexToDec("D0EA0")
    
    Do While DLL.REGISTRY.KeyExist(HKEY_CLASSES_ROOT_, "CLSID\" & CLASSID)
        id = id + 1
        Hex = DLL.MATH.DecToHex(id)
        CLASSID = "{00000000-0000-0000-8000-00AA000" & Hex & "}"
    Loop
    
    Call DLL.REGISTRY.KeyCreate(HKEY_CLASSES_ROOT_, "CLSID\" & CLASSID)
    Call DLL.REGISTRY.ValueSet(HKEY_CLASSES_ROOT_, "CLSID\" & CLASSID, "", AppName)
    Call DLL.REGISTRY.ValueSet(HKEY_CLASSES_ROOT_, "CLSID\" & CLASSID, "InfoTip", AppInfoTip)
    
    Call DLL.REGISTRY.KeyCreate(HKEY_CLASSES_ROOT_, "CLSID\" & CLASSID & "\DefaultIcon")
    Call DLL.REGISTRY.KeyCreate(HKEY_CLASSES_ROOT_, "CLSID\" & CLASSID & "\Shell\Open\command")
    Call DLL.REGISTRY.KeyCreate(HKEY_LOCAL_MACHINE_, "Software\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\" & CLASSID)
    
    Call DLL.REGISTRY.ValueSet(HKEY_LOCAL_MACHINE_, "Software\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\" & CLASSID, "", "YOUR APP")
    Call DLL.REGISTRY.ValueSet(HKEY_CLASSES_ROOT_, "CLSID\" & CLASSID & "\DefaultIcon", "", AppPath & ",0")
    Call DLL.REGISTRY.ValueSet(HKEY_CLASSES_ROOT_, "CLSID\" & CLASSID & "\Shell\Open\command", "", AppPath)

    Call Desktop_Update

End Sub
Public Function Desktops(Command As DeskCommand, ByVal DesktopName As String, _
                         Optional ByVal AppPath As String) As String()
    Dim x As Long, m_hDesktopThreadOld As Long, m_hDesktopInputOld As Long, m_hDesktop As Long, P As Long
    Dim pInfo As PROCESS_INFORMATION
    Dim sInfo As STARTUPINFO
    Dim sNull As String
    Dim A() As String
    
    Const DESKTOP_SWITCHDESKTOP = &H100&
    Const GENERIC_ALL = &H10000000

    On Local Error Resume Next
    
    Select Case Command
        Case dcGetDesktops
            Erase dcDesktops
            
            EnumDesktops GetProcessWindowStation, AddressOf EnumDesktopProc, 0
            
            A = basPModule.dcDesktops
            Desktops = A
        Case dcSwitchDesktop
            x = UBound(DA)
            
            If Err.Number <> 0 Then
                Err.Clear
                                                  
                Exit Function
            End If
            
            x = -1
            
            For P = LBound(DA) To UBound(DA)
                If DA(P).Name = DesktopName Then
                    x = P
                                                                   
                    Exit For
                End If
            Next P
            
            If x = -1 Then Exit Function
            
            Call SetThreadDesktop(DA(x).mDesktop)
            Call SwitchDesktop(DA(x).mDesktop)
        Case dcCreate_New
            m_hDesktopThreadOld = GetThreadDesktop(GetCurrentThreadId())
            m_hDesktopInputOld = OpenInputDesktop(0, False, DESKTOP_SWITCHDESKTOP)
            m_hDesktop = CreateDesktop(strptr(DesktopName), ByVal 0&, ByVal 0&, 0, GENERIC_ALL, ByVal 0&)
   
            x = UBound(DA)
            
            If Err.Number = 0 Then
                x = x + 1
            Else
                x = 0
                
                Err.Clear
            End If
        
            ReDim Preserve DA(x)
   
            With DA(x)
                .Name = DesktopName
                .OldThread = m_hDesktopThreadOld
                .OldInput = m_hDesktopInputOld
                .mDesktop = m_hDesktop
            End With
        Case dcExecute
            If DesktopName = "" Then
                Call DLL.SHELL.Execute(AppPath, , vbNormalFocus)
            Else
                sInfo.cb = Len(sInfo)
                sInfo.lpDesktop = DesktopName
    
                Call CreateProcess(sNull, AppPath, ByVal 0&, ByVal 0&, 1&, &H20&, _
                                   ByVal 0&, sNull, sInfo, pInfo)
            End If
        Case dcUnload
            x = UBound(DA)
            
            If Err.Number <> 0 Then
                Err.Clear
                Exit Function
            End If
            
            x = -1
    
            For P = LBound(DA) To UBound(DA)
                If DA(P).Name = DesktopName Then
                    x = P
                                                             
                    Exit For
                End If
            Next P
    
            If x = -1 Then Exit Function
    
            Call SwitchDesktop(DA(x).OldInput)
            Call SetThreadDesktop(DA(x).OldThread)
            Call CloseDesktop(DA(x).mDesktop)
            
            x = UBound(DA)
            
            If Err.Number = 0 Then
                If x = 0 Then Erase DA
            End If
        Case dcUnload_All
            x = UBound(DA)
            
            If Err.Number <> 0 Then
                Err.Clear
                Exit Function
            End If

            For P = LBound(DA) To UBound(DA)
                Call Desktops(dcUnload, DA(P).Name)
            Next P
            
            Erase DA
    End Select
    
Quit:
    Err.Clear
    
End Function
Public Function Get_Pixel(ByVal x As Long, Y As Long) As Long
    Dim hDC As Long, hw As Long
    
    hw = GetDesktopWindow()
    hDC = GetWindowDC(hw)
    Get_Pixel = GetPixel(hDC, x, Y)
    
    Call ReleaseDC(hw, hDC)

    Err.Clear
    
End Function
