Attribute VB_Name = "basFrmLimit"
Option Explicit

Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Declare Sub CopyMemory1 Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Sub CopyMemory2 Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Any, Source As Any, ByVal Length As Long)

Private Type MINMAXINFO
    ptReserved     As POINTAPI
    ptMaxSize      As POINTAPI
    ptMaxPosition  As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

Private WinOldProc As Long
Private spR As SIZEPAR
Private frm As Form

Public Sub InitFrmLimit(F As Form, R As SIZEPAR)
    
    spR = R
    Set frm = F
    
    WinOldProc = SetWindowLong(frm.hwnd, GWL_WNDPROC, AddressOf WindowProc)
    
End Sub
Public Sub UnHook()

    Call SetWindowLong(frm.hwnd, GWL_WNDPROC, WinOldProc)

End Sub
Private Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal _
                            wParam As Long, ByVal lParam&) As Long
    Dim Result As Long
    Dim MM As MINMAXINFO
    
    Const WM_GETMINMAXINFO As Long = &H24&
    
    If uMsg = WM_GETMINMAXINFO And frm.WINDOWSTATE = 0 Then
        Call CopyMemory1(MM, lParam, Len(MM))
        
        MM.ptMaxPosition.x = 0
        MM.ptMaxPosition.Y = 0
        MM.ptMaxSize.x = Screen.Width / Screen.TwipsPerPixelX
        MM.ptMaxSize.Y = Screen.Height / Screen.TwipsPerPixelY
        
        MM.ptMinTrackSize.x = spR.xMin
        MM.ptMinTrackSize.Y = spR.yMin
        MM.ptMaxTrackSize.x = spR.xMax
        MM.ptMaxTrackSize.Y = spR.yMax
        
        Call CopyMemory2(lParam&, MM, Len(MM))
        Result = DefWindowProc(hwnd, uMsg, wParam, lParam)
    Else
        Result = CallWindowProc(WinOldProc, hwnd, uMsg, wParam, lParam)
    End If
    
    WindowProc = Result
    
End Function
